library SOLEDROP;

{$R *.RES}

// ̈sRgAEg ANSI(MBCS) łɂȂ
{$DEFINE UNICODE}

uses
  Windows, ActiveX, ShlObj;

type
//////////////////////////////////////////////////////////////////////////
// L
//////////////////////////////////////////////////////////////////////////
    TSharedData = Record
        WM_OLEDROP_DLL: DWORD;
        sd_pt: TPoint;
        sd_hwnd: HWND;
        sd_hook: Hhook;
        sd_result: BOOL;
        sd_size: Int64;
        sd_files: Char;
    end;
    pSharedData = ^TSharedData;
//////////////////////////////////////////////////////////////////////////
// j[NiƂȁj
//////////////////////////////////////////////////////////////////////////
const
    FMOBJ_STR   = 'SOLEDROP_DLL_FMOBJ';
    MESSAGE_STR = 'SOLEDROP_DLL_MESSAGE';
//////////////////////////////////////////////////////////////////////////
// GUID
//////////////////////////////////////////////////////////////////////////
    IID_IDataObject: TGUID = (D1:$0000010E;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));
//////////////////////////////////////////////////////////////////////////
// 񑀍֌W
//////////////////////////////////////////////////////////////////////////
{$IFDEF UNICODE}
//////////////////////////////////////////////////////////////////////////
function LastDelimiterLiteW(const P: WChar; const S: WideString): Integer;
begin
    Result := Length(S);
    while Result>0 do
    begin
        if S[Result]=P then Exit;
        Dec(Result);
    end;
end;
//////////////////////////////////////////////////////////////////////////
function ExtractFilePathLiteW(const FileName: WideString): WideString;
begin
    Result := Copy(FileName, 1, LastDelimiterLiteW(WChar('\'), FileName));
end;
//////////////////////////////////////////////////////////////////////////
function ExtractFileNameLiteW(const FileName: WideString): WideString;
begin
    Result := Copy(FileName, LastDelimiterLiteW(WChar('\'), FileName) + 1, MaxInt);
end;
//////////////////////////////////////////////////////////////////////////
{$ELSE}
//////////////////////////////////////////////////////////////////////////
function LastDelimiterLiteA(const P: Char; const S: String): Integer;
begin
    Result := Length(S);
    while Result>0 do
    begin
        if S[Result]=P then
        begin
            if (Result>1) and IsDBCSLeadByte(Byte(S[Result - 1])) then
                Dec(Result)
            else
                Exit;
        end;
        Dec(Result);
    end;
end;
//////////////////////////////////////////////////////////////////////////
function ExtractFilePathLiteA(const FileName: String): String;
begin
    Result := Copy(FileName, 1, LastDelimiterLiteA('\', FileName));
end;
//////////////////////////////////////////////////////////////////////////
function ExtractFileNameLiteA(const FileName: String): String;
begin
    Result := Copy(FileName, LastDelimiterLiteA('\', FileName) + 1, MaxInt);
end;
{$ENDIF}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// t@C}bsO𐶐
//////////////////////////////////////////////////////////////////////////
function CreateFMOBJ(const iSize: Int64): THandle;
begin
{$IFDEF UNICODE}
    Result := CreateFileMappingW($FFFFFFFF, nil, PAGE_READWRITE,
                                  0, SizeOf(TSharedData) + iSize, WideString(FMOBJ_STR));
{$ELSE}
    Result := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE,
                                  0, SizeOf(TSharedData) + iSize, FMOBJ_STR);
{$ENDIF}
end;
//////////////////////////////////////////////////////////////////////////
// t@C}bsOj
//////////////////////////////////////////////////////////////////////////
procedure DestroyFMOBJ(const FMOBJ: THandle);
begin
    if FMOBJ<>0 then CloseHandle(FMOBJ);
end;
//////////////////////////////////////////////////////////////////////////
// t@C}bsOJ
//////////////////////////////////////////////////////////////////////////
function OpenFMOBJ(var h: THandle; var p: Pointer): BOOL;
begin
    Result := False;
{$IFDEF UNICODE}
    h := OpenFileMappingW(FILE_MAP_ALL_ACCESS, False, WideString(FMOBJ_STR));
{$ELSE}
    h := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, FMOBJ_STR);
{$ENDIF}
    if h=0 then Exit;
    p := MapViewOfFile(h, FILE_MAP_ALL_ACCESS, 0, 0, 0);
    if p=nil then
    begin
        CloseHandle(h);
        Exit;
    end;
    Result := True;
end;
//////////////////////////////////////////////////////////////////////////
// t@C}bsO
//////////////////////////////////////////////////////////////////////////
procedure CloseFMOBJ(const h: THandle; const p: Pointer);
begin
    if p<>nil then UnmapViewOfFile(p);
    if h<>0 then CloseHandle(h);
end;
//////////////////////////////////////////////////////////////////////////
// hbv
//////////////////////////////////////////////////////////////////////////
function DropFunc(const p: Pointer; const hDrop: THandle): BOOL;
var
    i, ilEffect, ilFileCount: Integer;
    ilCt: Int64;
    Count, Attr: Cardinal;
    pidls: array of PItemIDList;
    sfDesktop, sfFolder: IShellFolder;
    DropTarget: IDropTarget;
    DataObject: IDataObject;
    ilOffset: array of Integer;
{$IFDEF UNICODE}
    plFiles: PWChar;
    slTemp, slDirName, slFileName: WideString;
{$ELSE}
    plFiles: PChar;
    slTemp, slDirName, slFileName: String;
{$ENDIF}
begin
    Result := False;
    DropTarget := IDropTarget(Pointer(hDrop));
    with pSharedData(p)^ do
    begin
        if FAILED(SHGetDesktopFolder(sfDesktop)) then Exit;
        ilFileCount := 0;
        ilCt := 0;
        SetLength(ilOffset, 1);

        ilOffset[0] := 0;
{$IFDEF UNICODE}
        plFiles := PWChar(@sd_files);
        while PWChar(plFiles + ilCt)^<>WChar(#0) do
        begin
            while PWChar(plFiles + ilCt)^<>WChar(#0) do Inc(ilCt);
            Inc(ilCt);
            Inc(ilFileCount);
            SetLength(ilOffset, ilFileCount + 1);
            ilOffset[ilFileCount] := ilCt;
            if PWChar(plFiles + ilCt)^=WChar(#0) then Break;
            if (ilCt * 2)>sd_size then Break;
        end;
{$ELSE}
        plFiles := PChar(@sd_files);
        while (plFiles + ilCt)^<>#0 do
        begin
            while (plFiles + ilCt)^<>#0 do Inc(ilCt);
            Inc(ilCt);
            Inc(ilFileCount);
            SetLength(ilOffset, ilFileCount + 1);
            ilOffset[ilFileCount] := ilCt;
            if (plFiles + ilCt)^=#0 then Break;
            if ilCt>sd_size then Break;
        end;
{$ENDIF}
        if ilFileCount=0 then Exit;
        SetLength(pidls, ilFileCount);
        try
            for i:=0 to ilFileCount - 1 do
            begin
{$IFDEF UNICODE}
                slTemp := PWChar(plFiles + ilOffset[i]);
                slDirName  := ExtractFilePathLiteW(slTemp);
                slFileName := ExtractFileNameLiteW(slTemp);
{$ELSE}
                slTemp := PChar(plFiles + ilOffset[i]);
                slDirName  := ExtractFilePathLiteA(slTemp);
                slFileName := ExtractFileNameLiteA(slTemp);
{$ENDIF}
                if slFileName='' then Exit;
{$IFDEF UNICODE}
                if FAILED(sfDesktop.ParseDisplayName(0, nil, PWChar(slDirName),
                                                       Count, pidls[i], Attr)) then Exit;
{$ELSE}
                if FAILED(sfDesktop.ParseDisplayName(0, nil, PWChar(WideString(slDirName)),
                                                       Count, pidls[i], Attr)) then Exit;
{$ENDIF}
                if FAILED(sfDesktop.BindToObject(pidls[i], nil,
                            IID_IShellFolder, Pointer(sfFolder))) then Exit;
{$IFDEF UNICODE}
                if FAILED(sfFolder.ParseDisplayName(0, nil, PWChar(slFileName),
                                                  Count, pidls[i], Attr)) then Exit;
{$ELSE}
                if FAILED(sfFolder.ParseDisplayName(0, nil, PWChar(WideString(slFileName)),
                                                  Count, pidls[i], Attr)) then Exit;
{$ENDIF}
            end;
            if FAILED(sfFolder.GetUIObjectOf(0, ilFileCount, pidls[0],
                                IID_IDataObject, nil, Pointer(DataObject))) then Exit;
            if DataObject<>nil then
            begin
                ilEffect := DROPEFFECT_MOVE or DROPEFFECT_COPY or DROPEFFECT_LINK;
                DropTarget.DragEnter(DataObject, MK_LBUTTON, sd_pt, ilEffect);
                if (ilEffect<1) or (ilEffect>7) then
                begin
                    DropTarget.DragLeave;
                    Exit;
                end;
                ilEffect := DROPEFFECT_MOVE or DROPEFFECT_COPY or DROPEFFECT_LINK;
                DropTarget.DragOver(MK_LBUTTON, sd_pt, ilEffect);
                if (ilEffect<1) or (ilEffect>7) then
                begin
                    DropTarget.DragLeave;
                    Exit;
                end;
                ilEffect := DROPEFFECT_MOVE or DROPEFFECT_COPY or DROPEFFECT_LINK;
                Result := SUCCEEDED(DropTarget.Drop(DataObject, MK_LBUTTON, sd_pt, ilEffect));
            end;
        finally
            for i:=ilFileCount - 1 downto 0 do
            begin
                CoTaskMemFree(pidls[i]);
            end;
        end;
    end;
end;
//////////////////////////////////////////////////////////////////////////
// tbNvV[W
//////////////////////////////////////////////////////////////////////////
function HookProc(Code: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
    h, hlData: THandle;
    p: Pointer;
    hlHook: HHook;
    pcwp: PCWPSTRUCT;
begin
    if OpenFMOBJ(h, p) then
    begin
        with pSharedData(p)^ do
        begin
            hlHook := sd_hook;
            if HC_ACTION=Code then
            begin
                try
                    pcwp := Pointer(lParam);
                    if WM_OLEDROP_DLL=pcwp^.message then
                    begin
{$IFDEF UNICODE}
                        hlData := GetPropW(sd_hwnd, WideString('OleDropTargetInterface'));
{$ELSE}
                        hlData := GetProp(sd_hwnd, 'OleDropTargetInterface');
{$ENDIF}
                        if hlData<>0 then
                        begin
                            sd_result := DropFunc(p, hlData);
                        end;
                    end;
                except
                    sd_result := False;
                end;
            end;
        end;
        CloseFMOBJ(h, p);
        Result := CallNextHookEx(hlHook, Code, wParam, lParam);
    end
    else
    begin
// _Ȏ MSDN ɏ] 0 Ԃ
        Result := 0;
    end;
end;
//////////////////////////////////////////////////////////////////////////
// J֐
//////////////////////////////////////////////////////////////////////////
{$IFDEF UNICODE}
function OleDropProc(const hWin: HWND; const pt: TPoint; const pFiles: PWChar): BOOL; stdcall;
{$ELSE}
function OleDropProc(const hWin: HWND; const pt: TPoint; const pFiles: PChar): BOOL; stdcall;
{$ENDIF}
var
    h: THandle;
    p: Pointer;
    tid, dwMes: DWORD;
    hlHook: Hhook;
    FMOBJ: THandle;
    ilSize: Int64;
begin
    Result := False;
    ilSize := 0;
{$IFDEF UNICODE}
    while PWChar(pFiles + ilSize)^<>WChar(#0) do
    begin
        while PWChar(pFiles + ilSize)^<>WChar(#0) do Inc(ilSize);
        Inc(ilSize);
    end;
    Inc(ilSize);
    ilSize := ilSize * 2;
{$ELSE}
    while (pFiles + ilSize)^<>#0 do
    begin
        while (pFiles + ilSize)^<>#0 do Inc(ilSize);
        Inc(ilSize);
    end;
    Inc(ilSize);
{$ENDIF}
    FMOBJ := CreateFMOBJ(ilSize);
    if FMOBJ=0 then Exit;
    hlHook := 0;
    dwMes := 0;
    if OpenFMOBJ(h, p) then
    begin
        with pSharedData(p)^ do
        begin
            sd_pt := pt;
            sd_result := False;
            sd_hwnd := hWin;
            sd_size := ilSize;
            MoveMemory(@sd_files, pFiles, ilSize);
            tid := Windows.GetWindowThreadProcessId(hWin, nil);
{$IFDEF UNICODE}
            WM_OLEDROP_DLL := RegisterWindowMessageW(WideString(MESSAGE_STR));
            sd_hook := SetWindowsHookExW(WH_CALLWNDPROC, @HookProc, HInstance, tid);
{$ELSE}
            WM_OLEDROP_DLL := RegisterWindowMessage(MESSAGE_STR);
            sd_hook := SetWindowsHookEx(WH_CALLWNDPROC, @HookProc, HInstance, tid);
{$ENDIF}
            hlHook := sd_hook;
            dwMes := WM_OLEDROP_DLL;
        end;
        CloseFMOBJ(h, p);
    end;
    if (hlHook<>0) and (dwMes<>0) then
    begin
{$IFDEF UNICODE}
        SendMessageW(hWin, dwMes, 0, 0);
{$ELSE}
        SendMessage(hWin, dwMes, 0, 0);
{$ENDIF}
        UnhookWindowsHookEx(hlHook);
    end;
    if OpenFMOBJ(h, p) then
    begin
        Result := pSharedData(p)^.sd_result;
        CloseFMOBJ(h, p);
    end;
    DestroyFMOBJ(FMOBJ);
end;
//////////////////////////////////////////////////////////////////////////
exports
    OleDropProc;
//////////////////////////////////////////////////////////////////////////
begin
end.
//////////////////////////////////////////////////////////////////////////

